import sys, time

from omero.gateway import BlitzGateway
from path import path

def getPlane():
    conn = BlitzGateway("root", "omero", host="localhost", port=4064)
    conn.connect()
    #for imageIds in range(1,31): images 26/76 fails to render - known issue
    for imageIds in [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,27,28,29,30]:
        sumPlanes = []
        sumImage = []
        for imageId in (imageIds, imageIds+50):
            image = conn.getObject("Image", imageId)
            sizeX = image.getSizeX()
            sizeY = image.getSizeY()
            sizeZ = image.getSizeZ()
            sizeC = image.getSizeC()
            sizeT = image.getSizeT()
            
            zctList = []
            for z in range(sizeZ):
                for c in range(sizeC):
                    for t in range(sizeT):
                        zctList.append((z,c,t))
            
            ztList = []
            for z in range(sizeZ):
                for t in range(sizeT):
                    ztList.append((z,t))
            
            print path(image.getName()).name, " ",
            if image.getArchived():
                print "(fslite)",
            else:
                print "(pixels)",
            print " id=%d (X=%d, Y=%d, Z=%d, C=%d, T=%d)" % (imageId,sizeX,sizeY,sizeZ,sizeC,sizeT)

            count = 10
            timeList = []
            for i in range(count):
                startTime = time.time()
                pixels = image.getPrimaryPixels()
                planes = pixels.getPlanes(zctList)
                for plane in planes:
                    p = plane
                t1 = time.time() - startTime
                timeList.append(t1)
            print "Getplanes (secs): min = %.3f  max = %.3f  mean = %.3f" % (min(timeList),max(timeList),sum(timeList)/count)
            sumPlanes.append(sum(timeList))

            timeList = []
            for i in range(count):
                startTime = time.time()
                for zt in ztList:
                    z,t = zt
                    image.renderJpeg(z,t)
                t1 = time.time() - startTime
                timeList.append(t1)
            print "Render individual planes (secs): min = %.3f  max = %.3f  mean = %.3f" % (min(timeList),max(timeList),sum(timeList)/count)
            sumImage.append(sum(timeList))

        print "getPlanes %.3f" % (sumPlanes[0]/sumPlanes[1])
        print "renderImage %.3f" % (sumImage[0]/sumImage[1])
        print

        